#!/bin/sh

[ "$HD_APK" = 1 ] && is_apk=true || is_apk=false
($is_apk || test -f /system/dunehd_init) && is_android=true || is_android=false

$is_apk && priv= || priv="/system/dunehd/dunehd_service do"

###########################################################################
if $is_android; then
###########################################################################

cron_dir="$FS_PREFIX/tmp/cron/crontabs"
cron_file="$cron_dir/root"

[ ! -d "$cron_dir" ] && mkdir -p $cron_dir

$priv touch $cron_file

if [[ $# -eq 0 ]]; then
    cat $cron_file
    exit
fi

crons=`cat $cron_file`
while [ $# -gt 0 ]; do
    param="$1"
    if [[ $param = -* ]]; then
        crons=`echo "$crons" | grep -v "${param:1}"`
    elif [[ $param = +* ]]; then
        crons="$crons"$'\n'"${param:1}"
    fi
    shift
done
echo "New crons:"$'\n'"$crons" >> $FS_PREFIX/tmp/run/widget_ext.log
echo "$crons" > $cron_file

if ! $is_apk && [[ $(pgrep -l crond) ]]; then
    killall crond
fi

crond=crond
if $is_apk; then
  my_dir=$(cd $(dirname $0) && pwd)
  crond="sh $my_dir/crond.sh"
fi

$priv $crond -b -c $cron_dir

###########################################################################
else # is_android
###########################################################################

if [[ $# -eq 0 ]]; then
    crontab -u root -l
    exit
fi

command="(crontab -u root -l"
while [ $# -gt 0 ]; do
    param="$1"
    if [[ $param = -* ]]; then
        command="$command | grep -v '${param:1}'"
    elif [[ $param = +* ]]; then
        command="$command ; echo '${param:1}'"
    fi
    shift
done
command="$command) | crontab -u root -"
echo "Execute: $command" >> $FS_PREFIX/tmp/run/widget_ext.log
eval "$command"

###########################################################################
fi # is_android
###########################################################################
