#!/bin/sh
exec >>$FS_PREFIX/tmp/run/widget_ext.log 2>&1
BASEDIR=$(dirname "$(dirname "$(readlink -f "$0")")"); STORE_IFS=$IFS; IFS='/' path_array=($BASEDIR); IFS=$STORE_IFS; n=${#path_array[@]}
PLUGIN_NAME="${path_array[$n-1]}"
if [ -d /persistfs/plugins_data/$PLUGIN_NAME ]; then              
    DATA_DIR="/persistfs/plugins_data/$PLUGIN_NAME"
elif [ -d $FS_PREFIX/flashdata/plugins_data/$PLUGIN_NAME ]; then            
    DATA_DIR="$FS_PREFIX/flashdata/plugins_data/$PLUGIN_NAME"
else                          
    DATA_DIR=
fi

if [ -f /etc/TZ ]; then
    TZ=`cat /etc/TZ`; export TZ; date +"%d.%m.%Y %T"
else
    date +"%d.%m.%Y %T"
fi
echo "Installing Widget Ext..."
###########################################
# Needed for upgrade from 1.0.0 and 1.0.1 #
###########################################
echo "DATA_DIR: "$DATA_DIR
if [ -f $FS_PREFIX/tmp/run/widget_ext.properties ]; then
    cp $FS_PREFIX/tmp/run/widget_ext.properties $DATA_DIR/settings.properties
    echo "Copied: /tmp/run/widget_ext.properties to $DATA_DIR/settings.properties"
elif [ -f $BASEDIR/conf/settings.properties ]; then
    cp $BASEDIR/conf/settings.properties $DATA_DIR/settings.properties
    echo "Copied: $BASEDIR/conf/settings.properties to $DATA_DIR/settings.properties"
fi
if [ -f $FS_PREFIX/tmp/run/widget_ext.properties ]; then
    rm $FS_PREFIX/tmp/run/widget_ext.properties
    echo "Removed: /tmp/run/widget_ext.properties"
fi
if [ -f $BASEDIR/conf/settings.properties ]; then
    rm $BASEDIR/conf/settings.properties
    echo "Removed: $BASEDIR/conf/settings.properties"
fi
if [ -d $BASEDIR/conf ]; then
    rmdir $BASEDIR/conf
    echo "Removed: $BASEDIR/conf"
fi
###########################################
echo "Widget Ext installed"
