#!/bin/sh
# Author: slondon (forum.hdtv.ru)
BASEDIR=$(dirname "$(dirname "$(readlink -f "$0")")"); STORE_IFS=$IFS; IFS='/' path_array=($BASEDIR); IFS=$STORE_IFS; n=${#path_array[@]}
PLUGIN_NAME="${path_array[$n-1]}"
if [ -d /persistfs/plugins_data/$PLUGIN_NAME ]; then              
    DATA_DIR="/persistfs/plugins_data/$PLUGIN_NAME"
elif [ -d /flashdata/plugins_data/$PLUGIN_NAME ]; then            
    DATA_DIR="/flashdata/plugins_data/$PLUGIN_NAME"
else                          
    DATA_DIR=
fi

showMemInfo="no"
cleanMemoryThreshold=0
if [ -f $DATA_DIR/settings.properties ]
then
    exec <"$DATA_DIR/settings.properties"
    while true; do
        read key op value
        [ "$key" = "" ] && break
        [ "$key" = "showMemInfo" ] && showMemInfo="$value"
        [ "$key" = "cleanMemoryThreshold" ] && cleanMemoryThreshold="$value"
    done
fi

[ "$cleanMemoryThreshold" = "" ] && cleanMemoryThreshold=0
[ "$1" = "x" ] && cleanMemoryThreshold=100

[ "$showMemInfo" = "yes" ] || [ "$cleanMemoryThreshold" -gt 0 ] || exit

#freeMem=`egrep "MemFree" /proc/meminfo | cut -d':' -f 2 | sed -e 's/^[ \t]*//' | cut -d' ' -f 1`
freeMem=`sh $BASEDIR/bin/mem_available.sh`
totalMem=`egrep "MemTotal" /proc/meminfo | cut -d':' -f 2 | sed -e 's/^[ \t]*//' | cut -d' ' -f 1`
freePerc=$((($freeMem*1000+($totalMem/2))/$totalMem))

start2=`expr length $freePerc`
end1=$(($start2-1))
var1=`echo $freePerc | cut -c 1-$end1`
var2=`echo $freePerc | cut -c $start2-`
freePercStr=$var1'.'$var2'%'

in_array () {
  local e
  for e in "${@:2}"; do [[ "$e" == "$1" ]] && echo "yes"; done
  echo "no"
}

if [ "$cleanMemoryThreshold" -gt 0 ] && [ "$freePerc" -lt $(($cleanMemoryThreshold * 10)) ]
then
    rootPID=`ps -o pid,comm | grep '\<root\>' | sed -e 's/^[ \t]*//' | cut -d' ' -f 1`
    vvv='\<'$rootPID'\>'
    mainshellPID=`ps -o pid,ppid,comm | egrep $vvv' \<shell\>' | sed -e 's/^[ \t]*//' | cut -d' ' -f 1`
    vvv2='\<'$mainshellPID'\>'
    shellPIDs=`ps -o pid,ppid,args | egrep $vvv2' \<shell\>' | sed -e 's/^[ \t]*//' | cut -d' ' -f 1`
    if [ ! -z "$shellPIDs" -a "$shellPIDs" != " " ]; then
        lastShellPID=`cat /tmp/run/shell.log | grep 'PHP-server process has been started; pid:' | tail -n 1 -q | cut -d';' -f 2 | cut -d' ' -f 3 | cut -d'.' -f 1`
        if [ -z "$lastShellPID" -a -f /tmp/run/shell.log.old ]; then
            lastShellPID=`cat /tmp/run/shell.log.old | grep 'PHP-server process has been started; pid:' | tail -n 1 -q | cut -d';' -f 2 | cut -d' ' -f 3 | cut -d'.' -f 1`
        fi
        ignoredPlugins=""
        ignoredPIDs=""
        if [ -f $DATA_DIR/settings.properties ]; then
            exec <"$DATA_DIR/settings.properties"
            while true; do
                read key op value
                [ "$key" = "" ] && break
                [ "$key" = "ignoredPlugins" ] && ignoredPlugins="$value"
            done
        fi
        if [ "$ignoredPlugins" != "" ]; then
            if [[ "$ignoredPlugins" == *","* ]]; then
                cmd="cat /tmp/run/{$ignoredPlugins}.pid 2> /dev/null"
            else
                cmd="cat /tmp/run/$ignoredPlugins.pid 2> /dev/null"
            fi
            ignorePIDs=`eval "$cmd"`
            ignoredPIDsArray=($ignorePIDs)
        fi
        allPIDs=""    
        atLeastOneKilled="no"
        for pid in $shellPIDs; do
            pidStatus=""
            if [ "$lastShellPID" != "$pid" ]; then
                if [ "$ignoredPlugins" != "" ]; then           
                    ignored=$(in_array "$pid" "${ignoredPIDsArray[@]}")
                    if [ "$ignored" == "no" ]; then
                        pidStatus="killed"
                    else
                        pidStatus="ignored"
                    fi
                else
                    pidStatus="killed"
                fi
            else
                pidStatus="last run"
            fi
            pidInfo=$pid
            pidFile=`grep -lw $pid /tmp/run/*.pid`
            if [ "$pidFile" != "" ]; then
                pidFileLen=`expr length $pidFile`
                plugin=`echo "$pidFile" | cut -c 10-$(($pidFileLen-4))`
                pidInfo=$pidInfo" ("$plugin")"
            fi
            if [ "$pidStatus" == "killed" ]; then
                if [ "$pidFile" != "" ]; then
                    rm $pidFile
                fi
                kill $pid
                atLeastOneKilled="yes"
            fi
            allPIDs=$allPIDs"\n"$pidStatus" - "$pidInfo
        done
        if [ "$atLeastOneKilled" = "yes" ]; then
            #freeMem=`egrep "MemFree" /proc/meminfo | cut -d':' -f 2 | sed -e 's/^[ \t]*//' | cut -d' ' -f 1`
            freeMem=`sh $BASEDIR/bin/mem_available.sh`
            totalMem=`egrep "MemTotal" /proc/meminfo | cut -d':' -f 2 | sed -e 's/^[ \t]*//' | cut -d' ' -f 1`
            freePerc=$((($freeMem*1000+($totalMem/2))/$totalMem))
            start2=`expr length $freePerc`
            end1=$(($start2-1))
            var1=`echo $freePerc | cut -c 1-$end1`
            var2=`echo $freePerc | cut -c $start2-`
            freePercStr2=$var1'.'$var2'%'
            
            exec >/tmp/run/widget_ext_memory.log 2>&1
            if [ -f /etc/TZ ]; then
                TZ=`cat /etc/TZ`; export TZ; date +"%d.%m.%Y %T"
            else
                date +"%d.%m.%Y %T"
            fi
            echo -e "Free memory: "$freePercStr" -> "$freePercStr2$allPIDs
        fi
    fi    
fi
if [ "$showMemInfo" = "yes" ]
then
    WEATHER_FILE="/tmp/weather.txt"
    temp="0C"
    type="unknown"
    if [ -f $WEATHER_FILE ]
    then
        line=`cat $WEATHER_FILE`
        temp=`echo $line | cut -d' ' -f 1`
        type=`echo $line | cut -d' ' -f 2`
    fi
    echo "$temp $type $freePercStr" >"$WEATHER_FILE.tmp2"
    mv -f "$WEATHER_FILE.tmp2" "$WEATHER_FILE"
fi