#!/bin/sh

exec >>$FS_PREFIX/tmp/run/widget_ext.log 2>&1
BASEDIR=$(dirname "$(dirname "$(readlink -f "$0")")"); STORE_IFS=$IFS; IFS='/' path_array=($BASEDIR); IFS=$STORE_IFS; n=${#path_array[@]}
PLUGIN_NAME="${path_array[$n-1]}"
if [ -d /persistfs/plugins_data/$PLUGIN_NAME ]; then              
    DATA_DIR="/persistfs/plugins_data/$PLUGIN_NAME"
elif [ -d $FS_PREFIX/flashdata/plugins_data/$PLUGIN_NAME ]; then            
    DATA_DIR="$FS_PREFIX/flashdata/plugins_data/$PLUGIN_NAME"
else                          
    DATA_DIR=
fi

#if [ -f /etc/TZ ]; then
#    TZ=`cat /etc/TZ`; export TZ; date +"%d.%m.%Y %T"
#else
#    date +"%d.%m.%Y %T"
#fi
#echo "Starting weather update..."
fix_enabled="no"
if [ -f $DATA_DIR/settings.properties ]
then
    exec <"$DATA_DIR/settings.properties"
    while true; do
        read key op value
        [ "$key" = "" ] && break
        [ "$key" = "fix_enabled" ] && fix_enabled="$value"
    done
fi

[ "$fix_enabled" = "" -o "$fix_enabled" = "no" ] && exit
if [ "$fix_enabled" = "yes" ]; then
	fix_enabled="openweathermap"
fi

#echo "Weather service: "$fix_enabled

if [ "$fix_enabled" = "openweathermap" ]; then
	sh $BASEDIR/bin/weather_openweathermap.sh
elif [ "$fix_enabled" = "yandex" ]; then
	sh $BASEDIR/bin/weather_yandex.sh
elif [ "$fix_enabled" = "rp5" ]; then
    sh $BASEDIR/bin/weather_rp5.sh
elif [ "$fix_enabled" = "gismeteo" ]; then
    sh $BASEDIR/bin/weather_gismeteo.sh
#elif [ "$fix_enabled" = "test" ]; then
#    sh $BASEDIR/bin/weather_test.sh
fi
#echo "Weather update done"
