<?php 

class ViewUtils {
	
	public static function createRegularFolderView_List($initial_range, $actions) {
		$view = array(
			PluginFolderView::view_kind                 => PLUGIN_FOLDER_VIEW_REGULAR,
			PluginFolderView::multiple_views_supported  => false,
			PluginFolderView::data                      =>
				ViewUtils::createRegularFolderViewData_List($initial_range, $actions)
		);
		return $view;
	}
	
	public static function createRegularFolderViewData_List($initial_range, $actions) {
		return array(
			PluginRegularFolderView::async_icon_loading 			=> false,
			PluginRegularFolderView::initial_range 					=> $initial_range,
			PluginRegularFolderView::view_params 					=>
				ViewUtils::createRegularViewParams_List(),
			PluginRegularFolderView::base_view_item_params 			=>
				ViewUtils::createRegularBaseViewItemParams_List(),
			PluginRegularFolderView::not_loaded_view_item_params 	=> array(),
			PluginRegularFolderView::actions 						=> $actions
		);
	}
	
	public static function createRegularViewParams_List() {
		return array(
			ViewParams::num_cols => 1,
            ViewParams::num_rows => 12
		);
	}
	
	public static function createRegularBaseViewItemParams_List() {
		return array(
			ViewItemParams::icon_path => 'gui_skin://small_icons/folder.aai',
        	ViewItemParams::item_layout => HALIGN_LEFT,
        	ViewItemParams::icon_valign => VALIGN_CENTER,
        	ViewItemParams::icon_dx => 20,
        	ViewItemParams::icon_dy => -5,
        	ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
        	ViewItemParams::item_caption_width => 1550
		);
	}
	
	public static function createRegularFolderItem_List($media_url, $caption) {
		return array(
			PluginRegularFolderItem::caption 			=> $caption,
			PluginRegularFolderItem::media_url 			=> $media_url,
			PluginRegularFolderItem::view_item_params 	=>
				ViewUtils::createRegularBaseViewItemParams_List()
		);
	}
	
	public static function createRegularFolderItems($folder_items, $from_ndx=0, 
			$more_items_available=false, $total_num=false) {
		$count = count($folder_items);
		return array(
            PluginRegularFolderRange::total => $total_num === false ? $count : $total_num,
            PluginRegularFolderRange::count => $count,
            PluginRegularFolderRange::more_items_available => $more_items_available ? 1 : 0,
            PluginRegularFolderRange::from_ndx => $from_ndx,
            PluginRegularFolderRange::items => $folder_items
        );
	}
    
    public static function createAction($control_id, $handler_id, $caption=null) {
    	return array(
    		GuiAction::handler_string_id => PLUGIN_HANDLE_USER_INPUT_ACTION_ID,
    		GuiAction::caption => $caption,
    		GuiAction::data => null,
    		GuiAction::params => array(
    			'handler_id' => $handler_id,
    			'control_id' => $control_id
    		)
    	);
    }
    
    public static function update_regular_folder($range, $need_refresh = false,
    		$sel_ndx = -1) {
    	return array(
    		GuiAction::handler_string_id => PLUGIN_UPDATE_FOLDER_ACTION_ID,
    		GuiAction::data => array(
    			PluginUpdateFolderActionData::range => $range,
    			PluginUpdateFolderActionData::need_refresh => $need_refresh,
    			PluginUpdateFolderActionData::sel_ndx => intval($sel_ndx),
    		),
    	);
    }
    
    public static function returnAndUpdate($media_url) {
    	return array(
    		GuiAction::handler_string_id => PLUGIN_INVALIDATE_FOLDERS_ACTION_ID,
    		GuiAction::caption => "Refresh",
    		GuiAction::data => array(
    				PluginInvalidateFoldersActionData::media_urls => array($media_url),
//     				PluginInvalidateFoldersActionData::post_action => array(
//     						GuiAction::handler_string_id => RUN_DEFAULT_ACTION_ID,
//     				)
    		)
    	);
    }
}
?>